# org.pdfclown.documents.Page Class Reference

Document page [PDF:1.6:3.6.2]. More...

Inheritance diagram for org.pdfclown.documents.Page:

List of all members.

## Public Types
enum | TabOrderEnum { Row, Column, Structure }
| Annotations tab order [PDF:1.6:3.6.2]. More...
## Public Member Functions
virtual object | Clone (Document context)
| Gets a clone of the object, registered inside the given document context.
virtual bool | Delete ()
| Removes the object from its document context.
override bool | Equals (object obj)
override int | GetHashCode ()
| Page (Document context, drawing::SizeF?size)
| Creates a new page within the specified document context.
| Page (Document context)
| Creates a new page within the specified document context, using the default size.
void | Render (Graphics context, SizeF size)
void | Render (drawing::Graphics context, drawing::SizeF size)
ContentObject | ToInlineObject (PrimitiveComposer composer)
| Converts this entity to its equivalent inline (dependent) object representation [PDF:1.6:4.8.6].
xObjects::XObject | ToXObject (Document context)
| Converts this entity to its equivalent external (independent) object representation [PDF:1.6:4.7].
## Static Public Member Functions
static PdfDirectObject | GetBaseObject (PdfObjectWrapper wrapper)
| Gets the PDF object backing the specified wrapper.
static PdfDirectObject | GetInheritableAttribute (PdfDictionary pageObject, PdfName key)
| Gets the attribute value corresponding to the specified key, possibly recurring to its ancestor nodes in the page tree.
static Page | Wrap (PdfDirectObject baseObject)
## Static Public Attributes
static readonly ISet< PdfName > | InheritableAttributeKeys
## Protected Member Functions
void | CheckCompatibility (object feature)
| Checks whether the specified feature is compatible with the document's conformance version.
virtual PdfString | RetrieveName ()
| Retrieves the name possibly associated to this object, walking through the document's name dictionary.
PdfDirectObject | RetrieveNamedBaseObject ()
| Retrieves the object name, if available; otherwise, behaves like PdfObjectWrapper.BaseObject.
## Properties
PageActions | Actions`[get, set]`
| Gets/Sets the page's behavior in response to trigger events.
PageAnnotations | Annotations`[get, set]`
| Gets/Sets the annotations associated to the page.
drawing::RectangleF | ArtBox`[get, set]`
| Gets/Sets the extent of the page's meaningful content (including potential white space) as intended by the page's creator [PDF:1.7:10.10.1].
PageArticleElements | ArticleElements`[get]`
| Gets the page article beads.
virtual PdfDirectObject | BaseObject`[get, set]`
drawing::RectangleF | BleedBox`[get, set]`
| Gets/Sets the region to which the contents of the page should be clipped when output in a production environment [PDF:1.7:10.10.1].
drawing::RectangleF | Box`[get, set]`
| Gets the bounding box associated with this content context either explicitly (directly associated to the object) or (if not explicitly available) implicitly (inherited from a higher level object), expressed in default user-space units.
PdfIndirectObject | Container`[get]`
| Gets the indirect object containing the base object.
Contents | Contents`[get]`
| Gets the contents collection representing the content stream associated with this content context.
drawing::RectangleF | CropBox`[get, set]`
| Gets/Sets the region to which the contents of the page are to be clipped (cropped) when displayed or printed [PDF:1.7:10.10.1].
PdfIndirectObject | DataContainer`[get]`
| Gets the indirect object containing the base data object.
Document | Document`[get]`
| Gets the document context.
double | Duration`[get, set]`
| Gets/Sets the page's display duration.
File | File`[get]`
| Gets the file context.
int | Index`[get]`
| Gets the index of the page.
Resources | Resources`[get]`
| Gets the resources associated with this content context either explicitly (directly associated to the object) or (if not explicitly available) implicitly (inherited from a higher-level object).
RotationEnum | Rotation`[get, set]`
| Gets the rendering rotation of this content context.
drawing::SizeF | Size`[get, set]`
| Gets/Sets the page size.
TabOrderEnum | TabOrder`[get, set]`
| Gets/Sets the tab order to be used for annotations on the page.
Transition | Transition`[get, set]`
| Gets the transition effect to be used when displaying the page during presentations.
drawing::RectangleF | TrimBox`[get, set]`
| Gets/Sets the intended dimensions of the finished page after trimming [PDF:1.7:10.10.1].

##

Document page [PDF:1.6:3.6.2].

## Member Enumeration Documentation

enum org::pdfclown::documents::Page::TabOrderEnum

Annotations tab order [PDF:1.6:3.6.2].

Enumerator:

  Row | Row order.
  Column | Column order.
  Structure | Structure order.

## Constructor & Destructor Documentation

org.pdfclown.documents.Page.Page | ( | Document | context | ) |

Creates a new page within the specified document context, using the default size.

Parameters:

  | context | Document where to place this page.

org.pdfclown.documents.Page.Page | ( | Document | context,
|  | drawing::SizeF? | size |
| ) |  |  |

Creates a new page within the specified document context.

Parameters:

  | context | Document where to place this page.
  | size | Page size. In case of
      null
  , uses the default size.

## Member Function Documentation

void org.pdfclown.objects.PdfObjectWrapper.CheckCompatibility | ( | object | feature | ) | `[protected, inherited]`

Checks whether the specified feature is compatible with the document's conformance version.

Parameters:

  | feature | Entity whose compatibility has to be checked. Supported types: VersionEnum Property name resolvable to an annotated getter method MemberInfo

virtual object org.pdfclown.objects.PdfObjectWrapper.Clone | ( | Document | context | ) | `[virtual, inherited]`

Gets a clone of the object, registered inside the given document context.

Parameters:

  | context | Which document the clone has to be registered in.

virtual bool org.pdfclown.objects.PdfObjectWrapper.Delete | ( |  | ) | `[virtual, inherited]`

Removes the object from its document context.

The object is no more usable after this method returns.

Returns:
  Whether the object was actually decontextualized (only indirect objects can be decontextualize).

Reimplemented in org.pdfclown.documents.interaction.annotations.Annotation, org.pdfclown.documents.interaction.navigation.page.Article, and org.pdfclown.documents.interaction.navigation.page.ArticleElement.

override bool org.pdfclown.objects.PdfObjectWrapper.Equals | ( | object | obj | ) | `[inherited]`

Reimplemented in org.pdfclown.documents.contents.fonts.Font.

static PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.GetBaseObject | ( | PdfObjectWrapper< PdfDictionary > | wrapper | ) | `[static, inherited]`

Gets the PDF object backing the specified wrapper.

Parameters:

  | wrapper | Object to extract the base from.

override int org.pdfclown.objects.PdfObjectWrapper.GetHashCode | ( |  | ) | `[inherited]`

Reimplemented in org.pdfclown.documents.contents.fonts.Font.

static PdfDirectObject org.pdfclown.documents.Page.GetInheritableAttribute | ( | PdfDictionary | pageObject,
|  | PdfName | key |
| ) |  |  | `[static]`

Gets the attribute value corresponding to the specified key, possibly recurring to its ancestor nodes in the page tree.

Parameters:

  | pageObject | Page object.
  | key | Attribute key.

References org.pdfclown.objects.PdfDictionary.Resolve().

void org.pdfclown.documents.contents.IContentContext.Render | ( | Graphics | context,
|  | SizeF | size |
| ) |  |  | `[inherited]`

Renders this content context into the specified rendering context.

Parameters:

  | context | Rendering context.
  | size | Rendering canvas size.

Since:
  0.1.0

Referenced by org.pdfclown.tools.Renderer.Render().

void org.pdfclown.documents.Page.Render | ( | drawing::Graphics | context,
|  | drawing::SizeF | size |
| ) |  |  |

References org.pdfclown.documents.contents.ContentScanner.Render().

Referenced by org.pdfclown.tools.Renderer.PrintDocument.OnPrintPage().

virtual PdfString org.pdfclown.objects.PdfObjectWrapper.RetrieveName | ( |  | ) | `[protected, virtual, inherited]`

Retrieves the name possibly associated to this object, walking through the document's name dictionary.

Reimplemented in org.pdfclown.documents.multimedia.Rendition.

PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.RetrieveNamedBaseObject | ( |  | ) | `[protected, inherited]`

Retrieves the object name, if available; otherwise, behaves like PdfObjectWrapper.BaseObject.

ContentObject org.pdfclown.documents.Page.ToInlineObject | ( | PrimitiveComposer | composer | ) |

Converts this entity to its equivalent inline (dependent) object representation [PDF:1.6:4.8.6].

This method creates and shows an inline object within the target content context, returning it.

Due to its direct-content nature (opposite to the indirect-content nature of external objects), the resulting object should be shown only one time in order not to wastefully duplicate its data.

Parameters:

  | composer | Target content composer.

Returns:
  The inline object representing the entity.

Implements org.pdfclown.documents.contents.IContentEntity.

xObjects::XObject org.pdfclown.documents.Page.ToXObject | ( | Document | context | ) |

Converts this entity to its equivalent external (independent) object representation [PDF:1.6:4.7].

This method creates an external object within the target document, returning it. To show it in a content context (eg: a page), then it must be applied in an appropriate manner (see PrimitiveComposer object).

Parameters:

  | context | Target document.

Returns:
  The external object representing the entity.

Implements org.pdfclown.documents.contents.IContentEntity.

References org.pdfclown.bytes.IBuffer.Append(), org.pdfclown.objects.PdfObjectWrapper.Equals(), org.pdfclown.objects.PdfObject.Resolve(), and org.pdfclown.documents.contents.xObjects.FormXObject.Resources.

static Page org.pdfclown.documents.Page.Wrap | ( | PdfDirectObject | baseObject | ) | `[static]`

## Member Data Documentation

readonly ISet<PdfName> org.pdfclown.documents.Page.InheritableAttributeKeys`[static]`

## Property Documentation

PageActions org.pdfclown.documents.Page.Actions`[get, set]`

Gets/Sets the page's behavior in response to trigger events.

PageAnnotations org.pdfclown.documents.Page.Annotations`[get, set]`

Gets/Sets the annotations associated to the page.

drawing::RectangleF org.pdfclown.documents.Page.ArtBox`[get, set]`

Gets/Sets the extent of the page's meaningful content (including potential white space) as intended by the page's creator [PDF:1.7:10.10.1].

See also:
  CropBox

PageArticleElements org.pdfclown.documents.Page.ArticleElements`[get]`

Gets the page article beads.

virtual PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.BaseObject`[get, set, inherited]`

Gets the underlying reference object, if available; otherwise, gets the underlying data object.

drawing::RectangleF org.pdfclown.documents.Page.BleedBox`[get, set]`

Gets/Sets the region to which the contents of the page should be clipped when output in a production environment [PDF:1.7:10.10.1].

This may include any extra bleed area needed to accommodate the physical limitations of cutting, folding, and trimming equipment. The actual printed page may include printing marks that fall outside the bleed box.

See also:
  CropBox

drawing::RectangleF org.pdfclown.documents.Page.Box`[get, set]`

Gets the bounding box associated with this content context either explicitly (directly associated to the object) or (if not explicitly available) implicitly (inherited from a higher level object), expressed in default user-space units.

Implements org.pdfclown.documents.contents.IContentContext.

Referenced by org.pdfclown.documents.interaction.annotations.CalloutNote.LineObject.LineObject().

PdfIndirectObject org.pdfclown.objects.PdfObjectWrapper.Container`[get, inherited]`

Gets the indirect object containing the base object.

Contents org.pdfclown.documents.Page.Contents`[get]`

Gets the contents collection representing the content stream associated with this content context.

Implements org.pdfclown.documents.contents.IContentContext.

drawing::RectangleF org.pdfclown.documents.Page.CropBox`[get, set]`

Gets/Sets the region to which the contents of the page are to be clipped (cropped) when displayed or printed [PDF:1.7:10.10.1].

Unlike the other boxes, the crop box has no defined meaning in terms of physical page geometry or intended use; it merely imposes clipping on the page contents. However, in the absence of additional information, the crop box determines how the page's contents are to be positioned on the output medium.

See also:
  Box

PdfIndirectObject org.pdfclown.objects.PdfObjectWrapper.DataContainer`[get, inherited]`

Gets the indirect object containing the base data object.

Document org.pdfclown.objects.PdfObjectWrapper.Document`[get, inherited]`

Gets the document context.

double org.pdfclown.documents.Page.Duration`[get, set]`

Gets/Sets the page's display duration.

The page's display duration (also called its advance timing) is the maximum length of time, in seconds, that the page is displayed during presentations before the viewer application automatically advances to the next page.

By default, the viewer does not advance automatically.

File org.pdfclown.objects.PdfObjectWrapper.File`[get, inherited]`

Gets the file context.

int org.pdfclown.documents.Page.Index`[get]`

Gets the index of the page.

Referenced by org.pdfclown.documents.Pages.IndexOf(), and org.pdfclown.tools.PageManager.Split().

Resources org.pdfclown.documents.Page.Resources`[get]`

Gets the resources associated with this content context either explicitly (directly associated to the object) or (if not explicitly available) implicitly (inherited from a higher-level object).

The implementing class MUST ensure that the returned object isn't

    null

.

Implements org.pdfclown.documents.contents.IContentContext.

RotationEnum org.pdfclown.documents.Page.Rotation`[get, set]`

Gets the rendering rotation of this content context.

Implements org.pdfclown.documents.contents.IContentContext.

drawing::SizeF org.pdfclown.documents.Page.Size`[get, set]`

Gets/Sets the page size.

Referenced by org.pdfclown.documents.Document.GetSize().

TabOrderEnum org.pdfclown.documents.Page.TabOrder`[get, set]`

Gets/Sets the tab order to be used for annotations on the page.

Transition org.pdfclown.documents.Page.Transition`[get, set]`

Gets the transition effect to be used when displaying the page during presentations.

drawing::RectangleF org.pdfclown.documents.Page.TrimBox`[get, set]`

Gets/Sets the intended dimensions of the finished page after trimming [PDF:1.7:10.10.1].

It may be smaller than the media box to allow for production-related content, such as printing instructions, cut marks, or color bars.

See also:
  CropBox

Copyright 2006-2013 Stefano Chizzolini. For more information, please visit PDF Clown home page.